Create Outbound Interchange

This endpoint generates and delivers fully-formed EDI files to your trading partners.

POST/x12/partnerships/{partnershipId}/generate-edi

When you call this endpoint, Stedi:

  1. Generates a single EDI file containing all transactions according to the Stedi guide attached to each outbound transaction setting. This includes adding required envelope information (ISA and GS headers) and autogenerated control numbers.
  2. Delivers the EDI file to your trading partner through the connection specified in the transaction settings.

Transaction data

You must provide transaction data in Guide JSON format. The transaction data must be < 5MB.

Delivery attempts

Stedi attempts to deliver a file to all configured connections every 6 minutes for up to 3 total attempts. If it cannot deliver the file after the third attempt, it marks the file execution as FAILED and emits the file.failed.v2 event. Stedi displays each delivery attempt and the failure details on the Files page.

Customize generated files

You can change the timezone, time format, character set (which characters are allowed), and filename for generated files. Learn more.

Inbound processing

There is no equivalent endpoint for parsing EDI files into JSON. To parse inbound files, you or your partner can send EDI files to an SFTP/FTPS or AS2 connection, and Stedi sends the JSON payload to the configured Destination webhook.

Authorization
RequiredHeader

A production Stedi API Key for authentication.

Path Parameters

partnershipId
StringRegex pattern: ^([a-zA-Z0-9._-]+)$Length: 1 - 81

A unique ID for this partnership within Stedi. You can find this ID on the Trading partners page under Partnership identifier.

Headers

A unique string to identify this request to the server. The key can be up to 255 characters. You can safely retry requests with the same idempotency key within 24 hours of making the first request. This prevents sending duplicate data to your trading partners in case of network errors or other intermittent failures. Learn more.

Body

application/json

When generating EDI, the character set determines the set of characters allowed in the EDI message. Characters outside of the specified set (after applying any repairs specified in RepairOptions) will result in an error.

Possible values
Basic
Extended
ExtendedHipaa

Options for repairing EDI data during generation to ensure it meets X12 requirements

Show attributes
transactionGroups
Array of ObjectsRequiredMin items: 1

Contains one or more EDI functional groups, each containing the data for one or more EDI transactions. You can override the Application IDs (GS-02 and GS-03) for each group individually. The outbound transaction setting for each group must be configured to use the same connection. If you need to send transactions to different connections, you must call the endpoint multiple times.

Array item
filename
StringRegex pattern: ^([a-zA-Z0-9.*'()!_-]+)$Length: 1 - 300

Set a custom name for the generated EDI file. Stedi overwrites files with the same name, so we recommend making the filename unique by including a timestamp or other identifier. If you do not specify a filename, Stedi autogenerates a unique name using an ID.

overrides
Object
Show attributes

Set ISA-15 to a different value. If not set, the default value is P (Production Data).

Possible values
I
T
P

Set values for ISA header elements (ISA-01 to ISA-04).

Show attributes

Response

application/json
edi
String

The EDI Stedi generated from the JSON transaction data.

artifactId
StringRequired

An ID for the generated EDI file.

fileExecutionId
StringRequired

A ID for the process Stedi uses to generate the EDI file. This ID appears on the details page for this file execution in the Stedi portal. Internally, Stedi uses this ID to place the file in Stedi's outbound queue.

metadata
ObjectRequired

Metadata about the generated EDI file.

Show attributes